unit schFacturasClienteClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_DarReferencia = '{19462EB6-165A-476C-9823-5B2B47A082F8}';
  RID_FacturasCliente = '{8DDD5076-A7FE-4649-BD84-36A382C2DB9F}';
  RID_FacturasCliente_Detalles = '{C3991952-23C1-47BE-9530-07D295DBFF68}';
  RID_FacturasCliente_Detalles_Refresh = '{B6449FD9-7ECA-4803-88B5-43887E1AE8F9}';
  RID_FacturasCliente_Refresh = '{88BDA112-E109-4894-A64B-83C094E54A14}';

  { Data table names }
  nme_DarReferencia = 'DarReferencia';
  nme_FacturasCliente = 'FacturasCliente';
  nme_FacturasCliente_Detalles = 'FacturasCliente_Detalles';
  nme_FacturasCliente_Detalles_Refresh = 'FacturasCliente_Detalles_Refresh';
  nme_FacturasCliente_Refresh = 'FacturasCliente_Refresh';

  { DarReferencia fields }
  fld_DarReferenciaVALOR = 'VALOR';

  { DarReferencia field indexes }
  idx_DarReferenciaVALOR = 0;

  { FacturasCliente fields }
  fld_FacturasClienteID = 'ID';
  fld_FacturasClienteID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasClienteREFERENCIA = 'REFERENCIA';
  fld_FacturasClienteTIPO = 'TIPO';
  fld_FacturasClienteFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasClienteSITUACION = 'SITUACION';
  fld_FacturasClienteBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasClienteDESCUENTO = 'DESCUENTO';
  fld_FacturasClienteIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasClienteIVA = 'IVA';
  fld_FacturasClienteIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasClienteRE = 'RE';
  fld_FacturasClienteIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasClienteIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasClienteOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasClienteID_CLIENTE = 'ID_CLIENTE';
  fld_FacturasClienteNIF_CIF = 'NIF_CIF';
  fld_FacturasClienteNOMBRE = 'NOMBRE';
  fld_FacturasClienteCALLE = 'CALLE';
  fld_FacturasClientePOBLACION = 'POBLACION';
  fld_FacturasClientePROVINCIA = 'PROVINCIA';
  fld_FacturasClienteCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasClienteUSUARIO = 'USUARIO';
  fld_FacturasClienteID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasClienteRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasClienteID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasClienteIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasClienteIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasClienteID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_FacturasClienteREFERENCIA_COMISION = 'REFERENCIA_COMISION';
  fld_FacturasClienteID_AGENTE = 'ID_AGENTE';
  fld_FacturasClienteFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasCliente field indexes }
  idx_FacturasClienteID = 0;
  idx_FacturasClienteID_EMPRESA = 1;
  idx_FacturasClienteREFERENCIA = 2;
  idx_FacturasClienteTIPO = 3;
  idx_FacturasClienteFECHA_FACTURA = 4;
  idx_FacturasClienteSITUACION = 5;
  idx_FacturasClienteBASE_IMPONIBLE = 6;
  idx_FacturasClienteDESCUENTO = 7;
  idx_FacturasClienteIMPORTE_DESCUENTO = 8;
  idx_FacturasClienteIVA = 9;
  idx_FacturasClienteIMPORTE_IVA = 10;
  idx_FacturasClienteRE = 11;
  idx_FacturasClienteIMPORTE_RE = 12;
  idx_FacturasClienteIMPORTE_TOTAL = 13;
  idx_FacturasClienteOBSERVACIONES = 14;
  idx_FacturasClienteID_CLIENTE = 15;
  idx_FacturasClienteNIF_CIF = 16;
  idx_FacturasClienteNOMBRE = 17;
  idx_FacturasClienteCALLE = 18;
  idx_FacturasClientePOBLACION = 19;
  idx_FacturasClientePROVINCIA = 20;
  idx_FacturasClienteCODIGO_POSTAL = 21;
  idx_FacturasClienteFECHA_ALTA = 22;
  idx_FacturasClienteFECHA_MODIFICACION = 23;
  idx_FacturasClienteUSUARIO = 24;
  idx_FacturasClienteID_FORMA_PAGO = 25;
  idx_FacturasClienteRECARGO_EQUIVALENCIA = 26;
  idx_FacturasClienteID_TIPO_IVA = 27;
  idx_FacturasClienteIMPORTE_NETO = 28;
  idx_FacturasClienteIMPORTE_PORTE = 29;
  idx_FacturasClienteID_COMISION_LIQUIDADA = 30;
  idx_FacturasClienteREFERENCIA_COMISION = 31;
  idx_FacturasClienteID_AGENTE = 32;
  idx_FacturasClienteFECHA_VENCIMIENTO = 33;

  { FacturasCliente_Detalles fields }
  fld_FacturasCliente_DetallesID = 'ID';
  fld_FacturasCliente_DetallesID_FACTURA = 'ID_FACTURA';
  fld_FacturasCliente_DetallesPOSICION = 'POSICION';
  fld_FacturasCliente_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasCliente_DetallesCONCEPTO = 'CONCEPTO';
  fld_FacturasCliente_DetallesCANTIDAD = 'CANTIDAD';
  fld_FacturasCliente_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasCliente_DetallesDESCUENTO = 'DESCUENTO';
  fld_FacturasCliente_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasCliente_DetallesVISIBLE = 'VISIBLE';
  fld_FacturasCliente_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasCliente_DetallesREFERENCIA = 'REFERENCIA';
  fld_FacturasCliente_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasCliente_Detalles field indexes }
  idx_FacturasCliente_DetallesID = 0;
  idx_FacturasCliente_DetallesID_FACTURA = 1;
  idx_FacturasCliente_DetallesPOSICION = 2;
  idx_FacturasCliente_DetallesTIPO_DETALLE = 3;
  idx_FacturasCliente_DetallesCONCEPTO = 4;
  idx_FacturasCliente_DetallesCANTIDAD = 5;
  idx_FacturasCliente_DetallesIMPORTE_UNIDAD = 6;
  idx_FacturasCliente_DetallesDESCUENTO = 7;
  idx_FacturasCliente_DetallesIMPORTE_TOTAL = 8;
  idx_FacturasCliente_DetallesID_ARTICULO = 9;
  idx_FacturasCliente_DetallesVISIBLE = 10;
  idx_FacturasCliente_DetallesIMPORTE_PORTE = 11;
  idx_FacturasCliente_DetallesREFERENCIA = 12;
  idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR = 13;

  { FacturasCliente_Detalles_Refresh fields }
  fld_FacturasCliente_Detalles_RefreshID = 'ID';
  fld_FacturasCliente_Detalles_RefreshID_FACTURA = 'ID_FACTURA';
  fld_FacturasCliente_Detalles_RefreshPOSICION = 'POSICION';
  fld_FacturasCliente_Detalles_RefreshTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasCliente_Detalles_RefreshCONCEPTO = 'CONCEPTO';
  fld_FacturasCliente_Detalles_RefreshCANTIDAD = 'CANTIDAD';
  fld_FacturasCliente_Detalles_RefreshIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasCliente_Detalles_RefreshDESCUENTO = 'DESCUENTO';
  fld_FacturasCliente_Detalles_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_Detalles_RefreshID_ARTICULO = 'ID_ARTICULO';
  fld_FacturasCliente_Detalles_RefreshVISIBLE = 'VISIBLE';
  fld_FacturasCliente_Detalles_RefreshIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasCliente_Detalles_RefreshREFERENCIA = 'REFERENCIA';
  fld_FacturasCliente_Detalles_RefreshREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { FacturasCliente_Detalles_Refresh field indexes }
  idx_FacturasCliente_Detalles_RefreshID = 0;
  idx_FacturasCliente_Detalles_RefreshID_FACTURA = 1;
  idx_FacturasCliente_Detalles_RefreshPOSICION = 2;
  idx_FacturasCliente_Detalles_RefreshTIPO_DETALLE = 3;
  idx_FacturasCliente_Detalles_RefreshCONCEPTO = 4;
  idx_FacturasCliente_Detalles_RefreshCANTIDAD = 5;
  idx_FacturasCliente_Detalles_RefreshIMPORTE_UNIDAD = 6;
  idx_FacturasCliente_Detalles_RefreshDESCUENTO = 7;
  idx_FacturasCliente_Detalles_RefreshIMPORTE_TOTAL = 8;
  idx_FacturasCliente_Detalles_RefreshID_ARTICULO = 9;
  idx_FacturasCliente_Detalles_RefreshVISIBLE = 10;
  idx_FacturasCliente_Detalles_RefreshIMPORTE_PORTE = 11;
  idx_FacturasCliente_Detalles_RefreshREFERENCIA = 12;
  idx_FacturasCliente_Detalles_RefreshREFERENCIA_PROVEEDOR = 13;

  { FacturasCliente_Refresh fields }
  fld_FacturasCliente_RefreshID = 'ID';
  fld_FacturasCliente_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasCliente_RefreshREFERENCIA = 'REFERENCIA';
  fld_FacturasCliente_RefreshTIPO = 'TIPO';
  fld_FacturasCliente_RefreshFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasCliente_RefreshSITUACION = 'SITUACION';
  fld_FacturasCliente_RefreshBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasCliente_RefreshDESCUENTO = 'DESCUENTO';
  fld_FacturasCliente_RefreshIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasCliente_RefreshIVA = 'IVA';
  fld_FacturasCliente_RefreshIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasCliente_RefreshRE = 'RE';
  fld_FacturasCliente_RefreshIMPORTE_RE = 'IMPORTE_RE';
  fld_FacturasCliente_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_RefreshOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasCliente_RefreshID_CLIENTE = 'ID_CLIENTE';
  fld_FacturasCliente_RefreshNIF_CIF = 'NIF_CIF';
  fld_FacturasCliente_RefreshNOMBRE = 'NOMBRE';
  fld_FacturasCliente_RefreshCALLE = 'CALLE';
  fld_FacturasCliente_RefreshPOBLACION = 'POBLACION';
  fld_FacturasCliente_RefreshPROVINCIA = 'PROVINCIA';
  fld_FacturasCliente_RefreshCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasCliente_RefreshFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasCliente_RefreshFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasCliente_RefreshUSUARIO = 'USUARIO';
  fld_FacturasCliente_RefreshID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_FacturasCliente_RefreshRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_FacturasCliente_RefreshID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_FacturasCliente_RefreshIMPORTE_NETO = 'IMPORTE_NETO';
  fld_FacturasCliente_RefreshIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_FacturasCliente_RefreshID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_FacturasCliente_RefreshREFERENCIA_COMISION = 'REFERENCIA_COMISION';
  fld_FacturasCliente_RefreshID_AGENTE = 'ID_AGENTE';
  fld_FacturasCliente_RefreshFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasCliente_Refresh field indexes }
  idx_FacturasCliente_RefreshID = 0;
  idx_FacturasCliente_RefreshID_EMPRESA = 1;
  idx_FacturasCliente_RefreshREFERENCIA = 2;
  idx_FacturasCliente_RefreshTIPO = 3;
  idx_FacturasCliente_RefreshFECHA_FACTURA = 4;
  idx_FacturasCliente_RefreshSITUACION = 5;
  idx_FacturasCliente_RefreshBASE_IMPONIBLE = 6;
  idx_FacturasCliente_RefreshDESCUENTO = 7;
  idx_FacturasCliente_RefreshIMPORTE_DESCUENTO = 8;
  idx_FacturasCliente_RefreshIVA = 9;
  idx_FacturasCliente_RefreshIMPORTE_IVA = 10;
  idx_FacturasCliente_RefreshRE = 11;
  idx_FacturasCliente_RefreshIMPORTE_RE = 12;
  idx_FacturasCliente_RefreshIMPORTE_TOTAL = 13;
  idx_FacturasCliente_RefreshOBSERVACIONES = 14;
  idx_FacturasCliente_RefreshID_CLIENTE = 15;
  idx_FacturasCliente_RefreshNIF_CIF = 16;
  idx_FacturasCliente_RefreshNOMBRE = 17;
  idx_FacturasCliente_RefreshCALLE = 18;
  idx_FacturasCliente_RefreshPOBLACION = 19;
  idx_FacturasCliente_RefreshPROVINCIA = 20;
  idx_FacturasCliente_RefreshCODIGO_POSTAL = 21;
  idx_FacturasCliente_RefreshFECHA_ALTA = 22;
  idx_FacturasCliente_RefreshFECHA_MODIFICACION = 23;
  idx_FacturasCliente_RefreshUSUARIO = 24;
  idx_FacturasCliente_RefreshID_FORMA_PAGO = 25;
  idx_FacturasCliente_RefreshRECARGO_EQUIVALENCIA = 26;
  idx_FacturasCliente_RefreshID_TIPO_IVA = 27;
  idx_FacturasCliente_RefreshIMPORTE_NETO = 28;
  idx_FacturasCliente_RefreshIMPORTE_PORTE = 29;
  idx_FacturasCliente_RefreshID_COMISION_LIQUIDADA = 30;
  idx_FacturasCliente_RefreshREFERENCIA_COMISION = 31;
  idx_FacturasCliente_RefreshID_AGENTE = 32;
  idx_FacturasCliente_RefreshFECHA_VENCIMIENTO = 33;

type
  { IDarReferencia }
  IDarReferencia = interface(IDAStronglyTypedDataTable)
  ['{4A9A147C-F0D4-4D12-A078-E1628935D51C}']
    { Property getters and setters }
    function GetVALORValue: String;
    procedure SetVALORValue(const aValue: String);


    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;
  end;

  { TDarReferenciaDataTableRules }
  TDarReferenciaDataTableRules = class(TDADataTableRules, IDarReferencia)
  private
  protected
    { Property getters and setters }
    function GetVALORValue: String; virtual;
    procedure SetVALORValue(const aValue: String); virtual;

    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente }
  IFacturasCliente = interface(IDAStronglyTypedDataTable)
  ['{97F07602-AA17-43F5-B602-DF2652E5E44D}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetRECARGO_EQUIVALENCIAValue: Integer;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetREFERENCIA_COMISIONValue: String;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasClienteDataTableRules }
  TFacturasClienteDataTableRules = class(TDADataTableRules, IFacturasCliente)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetRECARGO_EQUIVALENCIAValue: Integer; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_COMISIONValue: String; virtual;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Detalles }
  IFacturasCliente_Detalles = interface(IDAStronglyTypedDataTable)
  ['{D4170DB7-FDD7-4E30-B782-BD714997C91F}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetIMPORTE_PORTEValue: Float;
    procedure SetIMPORTE_PORTEValue(const aValue: Float);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
  end;

  { TFacturasCliente_DetallesDataTableRules }
  TFacturasCliente_DetallesDataTableRules = class(TDADataTableRules, IFacturasCliente_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetIMPORTE_PORTEValue: Float; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Float); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Detalles_Refresh }
  IFacturasCliente_Detalles_Refresh = interface(IDAStronglyTypedDataTable)
  ['{6DE35809-3133-4554-9B41-CFD14D4D76E4}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetIMPORTE_PORTEValue: Float;
    procedure SetIMPORTE_PORTEValue(const aValue: Float);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
  end;

  { TFacturasCliente_Detalles_RefreshDataTableRules }
  TFacturasCliente_Detalles_RefreshDataTableRules = class(TDADataTableRules, IFacturasCliente_Detalles_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetIMPORTE_PORTEValue: Float; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Float); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property IMPORTE_PORTE: Float read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Refresh }
  IFacturasCliente_Refresh = interface(IDAStronglyTypedDataTable)
  ['{9012F341-ADE0-4953-B0D9-6D9F2C1AD246}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetRECARGO_EQUIVALENCIAValue: Integer;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetREFERENCIA_COMISIONValue: String;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasCliente_RefreshDataTableRules }
  TFacturasCliente_RefreshDataTableRules = class(TDADataTableRules, IFacturasCliente_Refresh)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetRECARGO_EQUIVALENCIAValue: Integer; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_COMISIONValue: String; virtual;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property RE: Float read GetREValue write SetREValue;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property RECARGO_EQUIVALENCIA: Integer read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TDarReferenciaDataTableRules }
constructor TDarReferenciaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDarReferenciaDataTableRules.Destroy;
begin
  inherited;
end;

function TDarReferenciaDataTableRules.GetVALORValue: String;
begin
  result := DataTable.Fields[idx_DarReferenciaVALOR].AsString;
end;

procedure TDarReferenciaDataTableRules.SetVALORValue(const aValue: String);
begin
  DataTable.Fields[idx_DarReferenciaVALOR].AsString := aValue;
end;


{ TFacturasClienteDataTableRules }
constructor TFacturasClienteDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasClienteDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteTIPO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteTIPO].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteSITUACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteSITUACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIVA].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIVA].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteRE].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteRE].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_RE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsString;
end;

procedure TFacturasClienteDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasClienteDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNOMBRE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNOMBRE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCALLE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCALLE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePOBLACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePOBLACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePROVINCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePROVINCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteUSUARIO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteUSUARIO].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetRECARGO_EQUIVALENCIAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteRECARGO_EQUIVALENCIA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasClienteDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetREFERENCIA_COMISIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIA_COMISIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteREFERENCIA_COMISION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_AGENTE].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_AGENTE].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


{ TFacturasCliente_DetallesDataTableRules }
constructor TFacturasCliente_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesDESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_PORTEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_PORTE].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;


{ TFacturasCliente_Detalles_RefreshDataTableRules }
constructor TFacturasCliente_Detalles_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_Detalles_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID_FACTURA].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID_FACTURA].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshPOSICION].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshPOSICION].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshTIPO_DETALLE].AsString;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshTIPO_DETALLE].AsString := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshCONCEPTO].AsString;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshCONCEPTO].AsString := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshCANTIDAD].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshCANTIDAD].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_UNIDAD].AsCurrency;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshDESCUENTO].AsFloat;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshDESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID_ARTICULO].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshID_ARTICULO].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshVISIBLE].AsInteger;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshVISIBLE].AsInteger := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetIMPORTE_PORTEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_PORTE].AsFloat;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetIMPORTE_PORTEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshIMPORTE_PORTE].AsFloat := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshREFERENCIA].AsString;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshREFERENCIA].AsString := aValue;
end;

function TFacturasCliente_Detalles_RefreshDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_Detalles_RefreshREFERENCIA_PROVEEDOR].AsString;
end;

procedure TFacturasCliente_Detalles_RefreshDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_Detalles_RefreshREFERENCIA_PROVEEDOR].AsString := aValue;
end;


{ TFacturasCliente_RefreshDataTableRules }
constructor TFacturasCliente_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_EMPRESA].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshTIPO].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshTIPO].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshSITUACION].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshSITUACION].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshDESCUENTO].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshDESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIVA].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIVA].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_IVA].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshRE].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshRE].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_RE].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasCliente_RefreshOBSERVACIONES].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_CLIENTE].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_CLIENTE].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshNIF_CIF].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshNIF_CIF].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshNOMBRE].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshNOMBRE].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshCALLE].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshCALLE].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshPOBLACION].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshPOBLACION].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshPROVINCIA].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshPROVINCIA].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshCODIGO_POSTAL].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_ALTA].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshUSUARIO].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshUSUARIO].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_FORMA_PAGO].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetRECARGO_EQUIVALENCIAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshRECARGO_EQUIVALENCIA].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshRECARGO_EQUIVALENCIA].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_TIPO_IVA].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_NETO].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetREFERENCIA_COMISIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA_COMISION].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetREFERENCIA_COMISIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA_COMISION].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_AGENTE].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_AGENTE].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


initialization
  RegisterDataTableRules(RID_DarReferencia, TDarReferenciaDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente, TFacturasClienteDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Detalles, TFacturasCliente_DetallesDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Detalles_Refresh, TFacturasCliente_Detalles_RefreshDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Refresh, TFacturasCliente_RefreshDataTableRules);

end.
